diff --git a/newlib/libm/common/isgreater.c b/newlib/libm/common/isgreater.c
index 54a8e6d42..cac9b10c4 100644
--- a/newlib/libm/common/isgreater.c
+++ b/newlib/libm/common/isgreater.c
@@ -17,7 +17,7 @@ INDEX
 INDEX
 	isunordered
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	int isgreater(real-floating <[x]>, real-floating <[y]>);
 	int isgreaterequal(real-floating <[x]>, real-floating <[y]>);
diff --git a/newlib/libm/common/s_cbrt.c b/newlib/libm/common/s_cbrt.c
index 95185d0fa..9289c368a 100644
--- a/newlib/libm/common/s_cbrt.c
+++ b/newlib/libm/common/s_cbrt.c
@@ -21,16 +21,11 @@ INDEX
 INDEX
 	cbrtf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double cbrt(double <[x]>);
 	float  cbrtf(float <[x]>);
 
-TRAD_SYNOPSIS
-	#include <math.h>
-	double cbrt(<[x]>);
-	float  cbrtf(<[x]>);
-
 DESCRIPTION
 	<<cbrt>> computes the cube root of the argument.
 
diff --git a/newlib/libm/common/s_copysign.c b/newlib/libm/common/s_copysign.c
index bfc546db5..4ea2d5f3e 100644
--- a/newlib/libm/common/s_copysign.c
+++ b/newlib/libm/common/s_copysign.c
@@ -20,21 +20,11 @@ INDEX
 INDEX
 	copysignf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double copysign (double <[x]>, double <[y]>);
 	float copysignf (float <[x]>, float <[y]>);
 
-TRAD_SYNOPSIS
-	#include <math.h>
-	double copysign (<[x]>, <[y]>)
-	double <[x]>;
-	double <[y]>;
-
-	float copysignf (<[x]>, <[y]>)
-	float <[x]>;
-	float <[y]>;
-
 DESCRIPTION
 <<copysign>> constructs a number with the magnitude (absolute value)
 of its first argument, <[x]>, and the sign of its second argument,
diff --git a/newlib/libm/common/s_exp10.c b/newlib/libm/common/s_exp10.c
index 23cedfbf3..08fa5ff16 100644
--- a/newlib/libm/common/s_exp10.c
+++ b/newlib/libm/common/s_exp10.c
@@ -20,19 +20,11 @@ INDEX
 INDEX
 	exp10f
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double exp10(double <[x]>);
 	float exp10f(float <[x]>);
 
-TRAD_SYNOPSIS
-	#include <math.h>
-	double exp10(<[x]>);
-	double <[x]>;
-
-	float exp10f(<[x]>);
-	float <[x]>;
-
 DESCRIPTION
 	<<exp10>> and <<exp10f>> calculate 10 ^ <[x]>, that is, 
 	@ifnottex
diff --git a/newlib/libm/common/s_expm1.c b/newlib/libm/common/s_expm1.c
index 12c88f16b..a4c391209 100644
--- a/newlib/libm/common/s_expm1.c
+++ b/newlib/libm/common/s_expm1.c
@@ -19,19 +19,11 @@ INDEX
 INDEX
 	expm1f
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double expm1(double <[x]>);
 	float expm1f(float <[x]>);
 
-TRAD_SYNOPSIS
-	#include <math.h>
-	double expm1(<[x]>);
-	double <[x]>;
-
-	float expm1f(<[x]>);
-	float <[x]>;
-
 DESCRIPTION
 	<<expm1>> and <<expm1f>> calculate the exponential of <[x]>
 	and subtract 1, that is,
diff --git a/newlib/libm/common/s_fdim.c b/newlib/libm/common/s_fdim.c
index a6c465cc4..73a027953 100644
--- a/newlib/libm/common/s_fdim.c
+++ b/newlib/libm/common/s_fdim.c
@@ -11,7 +11,7 @@ INDEX
 INDEX
 	fdimf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double fdim(double <[x]>, double <[y]>);
 	float fdimf(float <[x]>, float <[y]>);
diff --git a/newlib/libm/common/s_fma.c b/newlib/libm/common/s_fma.c
index bbb3eb09b..ab9e525b0 100644
--- a/newlib/libm/common/s_fma.c
+++ b/newlib/libm/common/s_fma.c
@@ -6,7 +6,7 @@ INDEX
 INDEX
 	fmaf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double fma(double <[x]>, double <[y]>, double <[z]>);
 	float fmaf(float <[x]>, float <[y]>, float <[z]>);
diff --git a/newlib/libm/common/s_fmax.c b/newlib/libm/common/s_fmax.c
index 8f446e216..f6fa5fc6a 100644
--- a/newlib/libm/common/s_fmax.c
+++ b/newlib/libm/common/s_fmax.c
@@ -11,7 +11,7 @@ INDEX
 INDEX
 	fmaxf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double fmax(double <[x]>, double <[y]>);
 	float fmaxf(float <[x]>, float <[y]>);
diff --git a/newlib/libm/common/s_fmin.c b/newlib/libm/common/s_fmin.c
index 2d0cd8021..9217c0251 100644
--- a/newlib/libm/common/s_fmin.c
+++ b/newlib/libm/common/s_fmin.c
@@ -11,7 +11,7 @@ INDEX
 INDEX
 	fminf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double fmin(double <[x]>, double <[y]>);
 	float fminf(float <[x]>, float <[y]>);
diff --git a/newlib/libm/common/s_ilogb.c b/newlib/libm/common/s_ilogb.c
index 477ec2e7c..cc5f7750b 100644
--- a/newlib/libm/common/s_ilogb.c
+++ b/newlib/libm/common/s_ilogb.c
@@ -19,20 +19,11 @@ INDEX
 INDEX
 	ilogbf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
         int ilogb(double <[val]>);
         int ilogbf(float <[val]>);
 
-TRAD_SYNOPSIS
-	#include <math.h>
-        int ilogb(<[val]>)
-        double <[val]>;
-
-        int ilogbf(<[val]>)
-        float <[val]>;
-
-
 DESCRIPTION
 
 	All nonzero, normal numbers can be described as <[m]> *
diff --git a/newlib/libm/common/s_infinity.c b/newlib/libm/common/s_infinity.c
index 9285a762f..990777d2c 100644
--- a/newlib/libm/common/s_infinity.c
+++ b/newlib/libm/common/s_infinity.c
@@ -12,7 +12,7 @@ INDEX
 INDEX
 	infinityf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double infinity(void);
 	float infinityf(void);
diff --git a/newlib/libm/common/s_isnan.c b/newlib/libm/common/s_isnan.c
index bc0a91631..91649dca4 100644
--- a/newlib/libm/common/s_isnan.c
+++ b/newlib/libm/common/s_isnan.c
@@ -43,7 +43,7 @@ INDEX
 	finitef
 @c SUSv2 end)
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	[C99 standard macros:]
 	#include <math.h>
 	int fpclassify(real-floating <[x]>);
diff --git a/newlib/libm/common/s_isnand.c b/newlib/libm/common/s_isnand.c
index 0ac8c5938..5f2c06467 100644
--- a/newlib/libm/common/s_isnand.c
+++ b/newlib/libm/common/s_isnand.c
@@ -27,7 +27,7 @@ INDEX
 INDEX
 	finitef
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	int isnan(double <[arg]>);
 	int isinf(double <[arg]>);
@@ -36,21 +36,6 @@ ANSI_SYNOPSIS
 	int isinff(float <[arg]>);
 	int finitef(float <[arg]>);
 
-TRAD_SYNOPSIS
-	#include <math.h>
-	int isnan(<[arg]>)
-	double <[arg]>;
-	int isinf(<[arg]>)
-	double <[arg]>;
-	int finite(<[arg]>);
-	double <[arg]>;
-	int isnanf(<[arg]>);
-	float <[arg]>;
-	int isinff(<[arg]>);
-	float <[arg]>;
-	int finitef(<[arg]>);
-	float <[arg]>;
-
 
 DESCRIPTION
 	These functions provide information on the floating-point
diff --git a/newlib/libm/common/s_log1p.c b/newlib/libm/common/s_log1p.c
index 351c887e7..359c257d8 100644
--- a/newlib/libm/common/s_log1p.c
+++ b/newlib/libm/common/s_log1p.c
@@ -20,19 +20,11 @@ INDEX
 INDEX
 	log1pf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double log1p(double <[x]>);
 	float log1pf(float <[x]>);
 
-TRAD_SYNOPSIS
-	#include <math.h>
-	double log1p(<[x]>)
-	double <[x]>;
-
-	float log1pf(<[x]>)
-	float <[x]>;
-
 DESCRIPTION
 <<log1p>> calculates 
 @tex
diff --git a/newlib/libm/common/s_log2.c b/newlib/libm/common/s_log2.c
index 3b05066b1..3655778e8 100644
--- a/newlib/libm/common/s_log2.c
+++ b/newlib/libm/common/s_log2.c
@@ -20,7 +20,7 @@ INDEX
 INDEX
 	log2f
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double log2(double <[x]>);
 	float log2f(float <[x]>);
diff --git a/newlib/libm/common/s_logb.c b/newlib/libm/common/s_logb.c
index 7e71457a5..26dfed01b 100644
--- a/newlib/libm/common/s_logb.c
+++ b/newlib/libm/common/s_logb.c
@@ -18,7 +18,7 @@ INDEX
 INDEX
 	logbf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
         double logb(double <[x]>);
         float logbf(float <[x]>);
diff --git a/newlib/libm/common/s_lrint.c b/newlib/libm/common/s_lrint.c
index 52bb52292..9d2cb7306 100644
--- a/newlib/libm/common/s_lrint.c
+++ b/newlib/libm/common/s_lrint.c
@@ -22,7 +22,7 @@ INDEX
 INDEX
 	llrintf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	long int lrint(double <[x]>);
 	long int lrintf(float <[x]>);
diff --git a/newlib/libm/common/s_lround.c b/newlib/libm/common/s_lround.c
index 52cd74f16..c0a4ebc40 100644
--- a/newlib/libm/common/s_lround.c
+++ b/newlib/libm/common/s_lround.c
@@ -20,7 +20,7 @@ INDEX
 INDEX
 	llroundf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	long int lround(double <[x]>);
 	long int lroundf(float <[x]>);
diff --git a/newlib/libm/common/s_matherr.c b/newlib/libm/common/s_matherr.c
index 58e242834..00d2caa38 100644
--- a/newlib/libm/common/s_matherr.c
+++ b/newlib/libm/common/s_matherr.c
@@ -19,15 +19,10 @@ FUNCTION
 INDEX 
 	matherr
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	int matherr(struct exception *<[e]>);
 
-TRAD_SYNOPSIS
-	#include <math.h>
-	int matherr(*<[e]>)
-	struct exception *<[e]>;
-
 DESCRIPTION
 <<matherr>> is called whenever a math library function generates an error.
 You can replace <<matherr>> by your own subroutine to customize
diff --git a/newlib/libm/common/s_modf.c b/newlib/libm/common/s_modf.c
index 2e9bfb125..8551a99e4 100644
--- a/newlib/libm/common/s_modf.c
+++ b/newlib/libm/common/s_modf.c
@@ -20,21 +20,11 @@ INDEX
 INDEX
 	modff
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double modf(double <[val]>, double *<[ipart]>);
         float modff(float <[val]>, float *<[ipart]>);
 
-TRAD_SYNOPSIS
-	#include <math.h>
-	double modf(<[val]>, <[ipart]>)
-        double <[val]>;
-        double *<[ipart]>;
-
-	float modff(<[val]>, <[ipart]>)
-	float <[val]>;
-        float *<[ipart]>;
-
 DESCRIPTION
 	<<modf>> splits the double <[val]> apart into an integer part
 	and a fractional part, returning the fractional part and
diff --git a/newlib/libm/common/s_nan.c b/newlib/libm/common/s_nan.c
index a98650db0..d5710385c 100644
--- a/newlib/libm/common/s_nan.c
+++ b/newlib/libm/common/s_nan.c
@@ -12,16 +12,11 @@ INDEX
 INDEX
 	nanf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double nan(const char *<[unused]>);
 	float nanf(const char *<[unused]>);
 
-TRAD_SYNOPSIS
-	#include <math.h>
-	double nan();
-	float nanf();
-
 
 DESCRIPTION
 	<<nan>> and <<nanf>> return an IEEE NaN (Not a Number) in
diff --git a/newlib/libm/common/s_nearbyint.c b/newlib/libm/common/s_nearbyint.c
index 714b66a5c..d142c68f2 100644
--- a/newlib/libm/common/s_nearbyint.c
+++ b/newlib/libm/common/s_nearbyint.c
@@ -16,7 +16,7 @@ INDEX
 INDEX
 	nearbyintf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double nearbyint(double <[x]>);
 	float nearbyintf(float <[x]>);
diff --git a/newlib/libm/common/s_nextafter.c b/newlib/libm/common/s_nextafter.c
index 3a7fa3fec..9453a0a00 100644
--- a/newlib/libm/common/s_nextafter.c
+++ b/newlib/libm/common/s_nextafter.c
@@ -20,23 +20,11 @@ INDEX
 INDEX
 	nextafterf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <math.h>
        double nextafter(double <[val]>, double <[dir]>);
        float nextafterf(float <[val]>, float <[dir]>);
 
-TRAD_SYNOPSIS
-       #include <math.h>
-
-       double nextafter(<[val]>, <[dir]>)
-              double <[val]>;
-              double <[exp]>;
-
-       float nextafter(<[val]>, <[dir]>)
-              float <[val]>;
-              float <[dir]>;
-
-
 DESCRIPTION
 <<nextafter>> returns the double-precision floating-point number
 closest to <[val]> in the direction toward <[dir]>.  <<nextafterf>>
diff --git a/newlib/libm/common/s_pow10.c b/newlib/libm/common/s_pow10.c
index 052e26d36..46645c71b 100644
--- a/newlib/libm/common/s_pow10.c
+++ b/newlib/libm/common/s_pow10.c
@@ -20,19 +20,11 @@ INDEX
 INDEX
 	pow10f
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double pow10(double <[x]>);
 	float pow10f(float <[x]>);
 
-TRAD_SYNOPSIS
-	#include <math.h>
-	double pow10(<[x]>);
-	double <[x]>;
-
-	float pow10f(<[x]>);
-	float <[x]>;
-
 DESCRIPTION
 	<<pow10>> and <<pow10f>> calculate 10 ^ <[x]>, that is, 
 	@ifnottex
diff --git a/newlib/libm/common/s_remquo.c b/newlib/libm/common/s_remquo.c
index 30bf15f14..468b56630 100644
--- a/newlib/libm/common/s_remquo.c
+++ b/newlib/libm/common/s_remquo.c
@@ -19,7 +19,7 @@ INDEX
 INDEX
 	remquof
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double remquo(double <[x]>, double <[y]>, int *<[quo]>);
 	float remquof(float <[x]>, float <[y]>, int *<[quo]>);
diff --git a/newlib/libm/common/s_rint.c b/newlib/libm/common/s_rint.c
index f06325a8d..7dce9f52b 100644
--- a/newlib/libm/common/s_rint.c
+++ b/newlib/libm/common/s_rint.c
@@ -18,7 +18,7 @@ INDEX
 INDEX
 	rintf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double rint(double <[x]>);
 	float rintf(float <[x]>);
diff --git a/newlib/libm/common/s_round.c b/newlib/libm/common/s_round.c
index 07aac9ecf..047574a84 100644
--- a/newlib/libm/common/s_round.c
+++ b/newlib/libm/common/s_round.c
@@ -16,7 +16,7 @@ INDEX
 INDEX
 	roundf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double round(double <[x]>);
 	float roundf(float <[x]>);
diff --git a/newlib/libm/common/s_scalbn.c b/newlib/libm/common/s_scalbn.c
index 7fab5861f..e9dbb16ac 100644
--- a/newlib/libm/common/s_scalbn.c
+++ b/newlib/libm/common/s_scalbn.c
@@ -23,7 +23,7 @@ INDEX
 INDEX
 	scalblnf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double scalbn(double <[x]>, int <[n]>);
 	float scalbnf(float <[x]>, int <[n]>);
diff --git a/newlib/libm/common/s_signbit.c b/newlib/libm/common/s_signbit.c
index d2ba1fcb9..098a32dfa 100644
--- a/newlib/libm/common/s_signbit.c
+++ b/newlib/libm/common/s_signbit.c
@@ -10,7 +10,7 @@ FUNCTION
 INDEX
 	signbit
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	int signbit(real-floating <[x]>);
 
diff --git a/newlib/libm/common/s_trunc.c b/newlib/libm/common/s_trunc.c
index 31a1f92b9..0e06add22 100644
--- a/newlib/libm/common/s_trunc.c
+++ b/newlib/libm/common/s_trunc.c
@@ -16,7 +16,7 @@ INDEX
 INDEX
 	truncf
 
-ANSI_SYNOPSIS
+SYNOPSIS
 	#include <math.h>
 	double trunc(double <[x]>);
 	float truncf(float <[x]>);