diff --git a/newlib/libm/complex/cabs.c b/newlib/libm/complex/cabs.c
index 69091d71a..b97579b43 100644
--- a/newlib/libm/complex/cabs.c
+++ b/newlib/libm/complex/cabs.c
@@ -19,7 +19,7 @@ INDEX
 INDEX
         cabsl
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double cabs(double complex <[z]>);
        float cabsf(float complex <[z]>);
diff --git a/newlib/libm/complex/cacos.c b/newlib/libm/complex/cacos.c
index 86e119842..2b0b82a56 100644
--- a/newlib/libm/complex/cacos.c
+++ b/newlib/libm/complex/cacos.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         cacosf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex cacos(double complex <[z]>);
        float complex cacosf(float complex <[z]>);
diff --git a/newlib/libm/complex/cacosh.c b/newlib/libm/complex/cacosh.c
index 3d42c407d..857b5c3a0 100644
--- a/newlib/libm/complex/cacosh.c
+++ b/newlib/libm/complex/cacosh.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         cacoshf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex cacosh(double complex <[z]>);
        float complex cacoshf(float complex <[z]>);
diff --git a/newlib/libm/complex/carg.c b/newlib/libm/complex/carg.c
index 044742034..f7efb40bd 100644
--- a/newlib/libm/complex/carg.c
+++ b/newlib/libm/complex/carg.c
@@ -17,7 +17,7 @@ INDEX
 INDEX
         cargf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double carg(double complex <[z]>);
        float cargf(float complex <[z]>);
diff --git a/newlib/libm/complex/casin.c b/newlib/libm/complex/casin.c
index 5019fd8cb..ced10531e 100644
--- a/newlib/libm/complex/casin.c
+++ b/newlib/libm/complex/casin.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         casinf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex casin(double complex <[z]>);
        float complex casinf(float complex <[z]>);
diff --git a/newlib/libm/complex/casinh.c b/newlib/libm/complex/casinh.c
index 16238a6e4..b4326b933 100644
--- a/newlib/libm/complex/casinh.c
+++ b/newlib/libm/complex/casinh.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         casinhf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex casinh(double complex <[z]>);
        float complex casinhf(float complex <[z]>);
diff --git a/newlib/libm/complex/catan.c b/newlib/libm/complex/catan.c
index bf9ea01ff..77510ec2f 100644
--- a/newlib/libm/complex/catan.c
+++ b/newlib/libm/complex/catan.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         catanf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex catan(double complex <[z]>);
        float complex catanf(float complex <[z]>);
diff --git a/newlib/libm/complex/catanh.c b/newlib/libm/complex/catanh.c
index 2b9ef9e47..1bb05559c 100644
--- a/newlib/libm/complex/catanh.c
+++ b/newlib/libm/complex/catanh.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         catanhf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex catanh(double complex <[z]>);
        float complex catanhf(float complex <[z]>);
diff --git a/newlib/libm/complex/ccos.c b/newlib/libm/complex/ccos.c
index 1062c079a..516632e56 100644
--- a/newlib/libm/complex/ccos.c
+++ b/newlib/libm/complex/ccos.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         ccosf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex ccos(double complex <[z]>);
        float complex ccosf(float complex <[z]>);
diff --git a/newlib/libm/complex/ccosh.c b/newlib/libm/complex/ccosh.c
index 223a5ed3a..818acc853 100644
--- a/newlib/libm/complex/ccosh.c
+++ b/newlib/libm/complex/ccosh.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         ccoshf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex ccosh(double complex <[z]>);
        float complex ccoshf(float complex <[z]>);
diff --git a/newlib/libm/complex/cexp.c b/newlib/libm/complex/cexp.c
index b9a3fd087..1c1291da2 100644
--- a/newlib/libm/complex/cexp.c
+++ b/newlib/libm/complex/cexp.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         cexpf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex cexp(double complex <[z]>);
        float complex cexpf(float complex <[z]>);
diff --git a/newlib/libm/complex/cimag.c b/newlib/libm/complex/cimag.c
index 959dbc9a4..a006cc72d 100644
--- a/newlib/libm/complex/cimag.c
+++ b/newlib/libm/complex/cimag.c
@@ -19,7 +19,7 @@ INDEX
 INDEX
         cimagl
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double cimag(double complex <[z]>);
        float cimagf(float complex <[z]>);
diff --git a/newlib/libm/complex/clog.c b/newlib/libm/complex/clog.c
index f7ad3d2f7..488f3b8fe 100644
--- a/newlib/libm/complex/clog.c
+++ b/newlib/libm/complex/clog.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         clogf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex clog(double complex <[z]>);
        float complex clogf(float complex <[z]>);
diff --git a/newlib/libm/complex/clog10.c b/newlib/libm/complex/clog10.c
index c857a65d9..f6cf45396 100644
--- a/newlib/libm/complex/clog10.c
+++ b/newlib/libm/complex/clog10.c
@@ -7,7 +7,7 @@ INDEX
 INDEX
         clog10f
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #define _GNU_SOURCE
        #include <complex.h>
        double complex clog10(double complex <[z]>);
diff --git a/newlib/libm/complex/conj.c b/newlib/libm/complex/conj.c
index dc50f085c..9e9d278b2 100644
--- a/newlib/libm/complex/conj.c
+++ b/newlib/libm/complex/conj.c
@@ -17,7 +17,7 @@ INDEX
 INDEX
         conjf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex conj(double complex <[z]>);
        float complex conjf(float complex <[z]>);
diff --git a/newlib/libm/complex/cpow.c b/newlib/libm/complex/cpow.c
index b60f7bea3..e7c419b63 100644
--- a/newlib/libm/complex/cpow.c
+++ b/newlib/libm/complex/cpow.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         cpowf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex cpow(double complex <[x]>, double complex <[y]>);
        float complex cpowf(float complex <[x]>, float complex <[y]>);
diff --git a/newlib/libm/complex/cproj.c b/newlib/libm/complex/cproj.c
index 32a757f92..184c71699 100644
--- a/newlib/libm/complex/cproj.c
+++ b/newlib/libm/complex/cproj.c
@@ -38,7 +38,7 @@ INDEX
 INDEX
         cprojf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex cproj(double complex <[z]>);
        float complex cprojf(float complex <[z]>);
diff --git a/newlib/libm/complex/creal.c b/newlib/libm/complex/creal.c
index 1652a5f8e..944afdd7f 100644
--- a/newlib/libm/complex/creal.c
+++ b/newlib/libm/complex/creal.c
@@ -19,7 +19,7 @@ INDEX
 INDEX
         creall
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double creal(double complex <[z]>);
        float crealf(float complex <[z]>);
diff --git a/newlib/libm/complex/csin.c b/newlib/libm/complex/csin.c
index cf6dae068..24702ed70 100644
--- a/newlib/libm/complex/csin.c
+++ b/newlib/libm/complex/csin.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         csinf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex csin(double complex <[z]>);
        float complex csinf(float complex <[z]>);
diff --git a/newlib/libm/complex/csinh.c b/newlib/libm/complex/csinh.c
index f11716262..b3f24eec8 100644
--- a/newlib/libm/complex/csinh.c
+++ b/newlib/libm/complex/csinh.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         csinhf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex csinh(double complex <[z]>);
        float complex csinhf(float complex <[z]>);
diff --git a/newlib/libm/complex/csqrt.c b/newlib/libm/complex/csqrt.c
index b144b7c3a..aecdcb40a 100644
--- a/newlib/libm/complex/csqrt.c
+++ b/newlib/libm/complex/csqrt.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         csqrtf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex csqrt(double complex <[z]>);
        float complex csqrtf(float complex <[z]>);
diff --git a/newlib/libm/complex/ctan.c b/newlib/libm/complex/ctan.c
index fb0db3497..0d6074baf 100644
--- a/newlib/libm/complex/ctan.c
+++ b/newlib/libm/complex/ctan.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         ctanf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex ctan(double complex <[z]>);
        float complex ctanf(float complex <[z]>);
diff --git a/newlib/libm/complex/ctanh.c b/newlib/libm/complex/ctanh.c
index db27e5b47..a86e97138 100644
--- a/newlib/libm/complex/ctanh.c
+++ b/newlib/libm/complex/ctanh.c
@@ -41,7 +41,7 @@ INDEX
 INDEX
         ctanhf
 
-ANSI_SYNOPSIS
+SYNOPSIS
        #include <complex.h>
        double complex ctanh(double complex <[z]>);
        float complex ctanhf(float complex <[z]>);